## onnx 1.17.0

=== requirements.txt ===
numpy>=1.20
protobuf>=3.20.2

=== docs/docsgen/source/requirements.txt ===

furo
markupsafe
matplotlib
myst-parser[linkify]
onnx
onnxruntime
pillow
pydot
sphinx-copybutton
sphinx-exec-code
sphinx-gallery
sphinx-tabs
sphinx

=== debian/changelog ===
onnx (1.17.0-3build2) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 20 Oct 2025 14:18:17 +0000

onnx (1.17.0-3build1) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Mar 2025 17:42:48 +0000

onnx (1.17.0-3) unstable; urgency=medium

  * Autopkgtest: mask problematic tests for armel, riscv64, s390x.
  * Apply wrap-and-sort.
  * Copyright: bump year.
  * d/control: Fix capitalization error in description.
  * d/control: update package Section based on lintian I.
  * d/copyright: fix spelling error.
  * Bump Standards-Version to 4.7.0. No change needed.

 -- Mo Zhou <lumin@debian.org>  Thu, 30 Jan 2025 12:26:22 -0500

onnx (1.17.0-2) unstable; urgency=medium

  * Upload to unstable. (Closes: #1075852) (Fixes: CVE-2024-5187)
    The CVE was already fixed in the 1.16.2 release. I forgot to
    close the bug back then.

 -- Mo Zhou <lumin@debian.org>  Thu, 23 Jan 2025 11:21:11 -0500

onnx (1.17.0-1) experimental; urgency=medium

  * New upstream version 1.17.0
    Please pin to this version for PyTorch/v2.6.X release.
  * quilt: Refresh existing patches.
  * Autopkgtest: add the missing dependency python3-pi.
  * Patch code to avoid dependency on re2.
  * Autopkgtest: gate migration with CI results.
  * Upload to experimental.

 -- Mo Zhou <lumin@debian.org>  Mon, 20 Jan 2025 18:24:12 +0000

=== debian/control ===
Source: onnx
Section: science
Homepage: https://onnx.ai
Priority: optional
Standards-Version: 4.7.0
Vcs-Git: https://salsa.debian.org/deeplearning-team/onnx.git
Vcs-Browser: https://salsa.debian.org/deeplearning-team/onnx
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>
Build-Depends: debhelper-compat (= 12),
               dh-exec,
               dh-python,
               dpkg-dev (>= 1.22.5),
               cmake,
               libprotobuf-dev,
               protobuf-compiler,
               pybind11-dev,
               python3-all,
               python3-all-dev,
               python3-numpy <!nocheck>,
               python3-protobuf <!nocheck>,
               python3-pybind11,
               python3-pytest <!nocheck>,
               python3-pytest-runner,
               python3-tabulate <!nocheck>
Rules-Requires-Root: no

Package: python3-onnx
Architecture: any
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Provides: ${python3:Provides}
Description: Open Neural Network Exchange (ONNX) (Python)
 Open Neural Network Exchange (ONNX) is the first step toward an open ecosystem
 that empowers AI developers to choose the right tools as their project evolves.
 ONNX provides an open source format for AI models.  It defines an extensible
 computation graph model, as well as definitions of built-in operators and
 standard data types. Initially onnx focuses on the capabilities needed for
 inferencing (evaluation).
 .
 Caffe2, PyTorch, Microsoft Cognitive Toolkit, Apache MXNet and other tools are
 developing ONNX support. Enabling interoperability between different frameworks
 and streamlining the path from research to production will increase the speed
 of innovation in the AI community.
 .
 This package contains the Python interface.

Package: libonnx1t64
Section: libs
Provides: ${t64:Provides}
Replaces: libonnx1
Breaks: libonnx1 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Open Neural Network Exchange (ONNX) (libs)
 Open Neural Network Exchange (ONNX) is the first step toward an open ecosystem
 that empowers AI developers to choose the right tools as their project evolves.
 ONNX provides an open source format for AI models.  It defines an extensible
 computation graph model, as well as definitions of built-in operators and
 standard data types. Initially onnx focuses on the capabilities needed for
 inferencing (evaluation).
 .
 Caffe2, PyTorch, Microsoft Cognitive Toolkit, Apache MXNet and other tools are
 developing ONNX support. Enabling interoperability between different frameworks
 and streamlining the path from research to production will increase the speed
 of innovation in the AI community.
 .
 This package contains the shared objects.

Package: libonnx-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libonnx1t64 (= ${binary:Version}), ${misc:Depends}
Description: Open Neural Network Exchange (ONNX) (dev)
 Open Neural Network Exchange (ONNX) is the first step toward an open ecosystem
 that empowers AI developers to choose the right tools as their project evolves.
 ONNX provides an open source format for AI models.  It defines an extensible
 computation graph model, as well as definitions of built-in operators and
 standard data types. Initially onnx focuses on the capabilities needed for
 inferencing (evaluation).
 .
 Caffe2, PyTorch, Microsoft Cognitive Toolkit, Apache MXNet and other tools are
 developing ONNX support. Enabling interoperability between different frameworks
 and streamlining the path from research to production will increase the speed
 of innovation in the AI community.
 .
 This package contains the development files.

Package: libonnx-testdata
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Open Neural Network Exchange (ONNX) (test data)
 Open Neural Network Exchange (ONNX) is the first step toward an open ecosystem
 that empowers AI developers to choose the right tools as their project evolves.
 ONNX provides an open source format for AI models.  It defines an extensible
 computation graph model, as well as definitions of built-in operators and
 standard data types. Initially onnx focuses on the capabilities needed for
 inferencing (evaluation).
 .
 Caffe2, PyTorch, Microsoft Cognitive Toolkit, Apache MXNet and other tools are
 developing ONNX support. Enabling interoperability between different frameworks
 and streamlining the path from research to production will increase the speed
 of innovation in the AI community.
 .
 This package contains the test data.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# `CMAKE_ARGS` is for passing cmake arguments to setup.py
# We will also pass this to the direct cmake build.
export CMAKE_ARGS              = -DONNX_USE_PROTOBUF_SHARED_LIBS=ON \
                                 -DBUILD_SHARED_LIBS=ON \
                                 -DONNX_BUILD_TESTS=OFF \
                                 -DCMAKE_BUILD_TYPE=Release \
                                 -DBUILD_ONNX_PYTHON=ON \
                                 -Dprotobuf_BUILD_SHARED_LIBS=OFF \
                                 -DCMAKE_POSITION_INDEPENDENT_CODE=ON \
                                 -Dprotobuf_BUILD_TESTS=OFF \
                                 -DCMAKE_VERBOSE_MAKEFILE=ON

%:
	dh $@ -Spybuild --with python3

override_dh_auto_configure:
	# XXX: the find | sed command is written in fix-shebang.patch
	#find . -type f -name '*.py' -exec \
    #    sed -i -e 's@#!/usr/bin/env python@#!/usr/bin/python3@' '{}' +
	dh_auto_configure -Scmake -- $(CMAKE_ARGS)
	dh_auto_configure -Spybuild

override_dh_auto_build:
	: # so things won't be built again while installing

override_dh_auto_test:
	:

override_dh_auto_install:
	dh_auto_install -Scmake
	dh_auto_install -Spybuild
	# Remove duplicatd test data from include directory
	-$(RM) -rf debian/tmp/usr/include/onnx/backend/test/data
	# Use the test data installed in python package as the main copy
	mkdir -v -p debian/libonnx-testdata/usr/share/libonnx-testdata/
	mv debian/tmp/usr/lib/$(shell py3versions -d)/dist-packages/onnx/backend/test/data \
	   debian/libonnx-testdata/usr/share/libonnx-testdata/
	-$(RM) -rf debian/tmp/usr/lib/python3*/dist-packages/onnx/backend/test/data
	# install the python package
	mkdir -p debian/python3-onnx/usr/lib/python3
	for py3 in $(shell py3versions -s); do \
		cp -av debian/tmp/usr/lib/$${py3}/dist-packages debian/python3-onnx/usr/lib/python3/; \
		rm -rf debian/tmp/usr/lib/$${py3}/dist-packages; done

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_clean:
	dh_auto_clean -Scmake
	dh_auto_clean -Spybuild
	-$(RM) -rf .setuptools-cmake-build
	# XXX: those are auto generated files.
	-$(RM) onnx/onnx_data_pb.py onnx/onnx_data_pb2.py onnx/onnx_data_pb2.pyi \
		onnx/onnx_ml_pb2.py onnx/onnx_ml_pb2.pyi onnx/onnx_operators_ml_pb2.py \
		onnx/onnx_operators_ml_pb2.pyi onnx/onnx_operators_pb.py onnx/onnx_pb.py \
		onnx/version.py

## onnx 1.19.1

=== CMakeLists.txt ===
# Minimum CMake required
cmake_minimum_required(VERSION 3.24)
# Project
project(onnx LANGUAGES CXX)

include(cmake/Utils.cmake)
# Honor visibility properties for all target types.
cmake_policy(SET CMP0063 NEW)

# Set default build type
get_property(isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
if(NOT isMultiConfig AND NOT CMAKE_BUILD_TYPE)
  message(STATUS "Build type not set - defaulting to Release")
  set(
    CMAKE_BUILD_TYPE "Release"
    CACHE
      STRING
      "Choose the type of build from: Debug Release RelWithDebInfo MinSizeRel Coverage."
    FORCE)
endif()

# https://reproducible-builds.org/docs/source-date-epoch/
if(DEFINED ENV{SOURCE_DATE_EPOCH})
  execute_process(
    COMMAND "date" "-u" "-d" "@$ENV{SOURCE_DATE_EPOCH}" "+%Y-%m-%d"
    OUTPUT_VARIABLE BUILD_DATE
    OUTPUT_STRIP_TRAILING_WHITESPACE)
else()
  execute_process(
    COMMAND "date" "+%Y-%m-%d"
    OUTPUT_VARIABLE BUILD_DATE
    OUTPUT_STRIP_TRAILING_WHITESPACE)
endif()

if(NOT BUILD_SHARED_LIBS)
  # by default, cmake builds static libraries
  set(BUILD_SHARED_LIBS OFF)
endif()


if(DEFINED BUILD_ONNX_PYTHON)
  message(WARNING "'BUILD_ONNX_PYTHON' is deprecated. Please, use 'ONNX_BUILD_PYTHON' instead")
  set(ONNX_BUILD_PYTHON_DEFAULT ${BUILD_ONNX_PYTHON})
else()
  set(ONNX_BUILD_PYTHON_DEFAULT OFF)
endif()

option(ONNX_BUILD_PYTHON "Build Python binaries" ${ONNX_BUILD_PYTHON_DEFAULT})
option(ONNX_BUILD_CUSTOM_PROTOBUF "Build and use ONNX's own protobuf" OFF)
option(ONNX_USE_PROTOBUF_SHARED_LIBS "Build ONNX using protobuf shared library." OFF)
option(ONNX_GEN_PB_TYPE_STUBS "Generate protobuf python type stubs" ON)
option(ONNX_WERROR "Build with Werror" OFF)
option(ONNX_COVERAGE "Build with coverage instrumentation" OFF)
option(ONNX_BUILD_TESTS "Build ONNX C++ APIs Tests" OFF)
option(ONNX_USE_ASAN "Build ONNX with ASAN" OFF)
option(ONNX_USE_LITE_PROTO "Use lite protobuf instead of full." OFF)
option(ONNX_DISABLE_EXCEPTIONS "Disable exception handling." OFF)
option(ONNX_DISABLE_STATIC_REGISTRATION "Disable static registration for ONNX operator schemas." OFF)
option(ONNX_USE_UNITY_BUILD "Enable Unity (Jumbo) build for" OFF)
if(WIN32)
  option(ONNX_USE_MSVC_STATIC_RUNTIME "Build with MSVC static runtime" OFF)
endif()

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

if(NOT DEFINED ONNX_ML)
  if(DEFINED ENV{ONNX_ML})
    set(DEFAULT_ONNX_ML $ENV{ONNX_ML})
  else()
    set(DEFAULT_ONNX_ML ON)
  endif()
  option(ONNX_ML "Enable traditional ML API." ${DEFAULT_ONNX_ML})
endif()

if(NOT DEFINED ONNX_VERIFY_PROTO3)
  if(DEFINED ENV{ONNX_VERIFY_PROTO3})
    set(PROTO3_ENABLED $ENV{ONNX_VERIFY_PROTO3})
  else()
    set(PROTO3_ENABLED OFF)
  endif()
  option(ONNX_VERIFY_PROTO3 "Generate code by proto3" ${PROTO3_ENABLED})
endif()

if(NOT DEFINED CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 17)
else()
  if(CMAKE_CXX_STANDARD VERSION_LESS 17)
    message(FATAL_ERROR "At least C++17 is required.")
  endif()
endif()

include(GNUInstallDirs)

set(ONNX_ROOT ${onnx_SOURCE_DIR})

# Read ONNX version
file(READ "${ONNX_ROOT}/VERSION_NUMBER" ONNX_VERSION)
string(STRIP "${ONNX_VERSION}" ONNX_VERSION)

if(NOT MSVC)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wnon-virtual-dtor")
  set(CMAKE_C_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0")
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0")
  if(ONNX_COVERAGE)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fprofile-arcs -ftest-coverage")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage")
  endif()
endif()

if(NOT ONNX_NAMESPACE)
  set(ONNX_NAMESPACE "onnx")
endif()

if(MSVC)
  if(NOT ONNX_DISABLE_EXCEPTIONS)
    string(APPEND CMAKE_CXX_FLAGS " /EHsc /wd26812")
    string(APPEND CMAKE_C_FLAGS " /EHsc /wd26812")
  endif()
  add_compile_options(/MP /utf-8 /nologo)
  add_compile_options(
    /wd5287  # https://developercommunity.visualstudio.com/t/warning-C5287:-operands-are-different-e/10877942?sort=newest
    /Zc:lambda  # https://developercommunity.visualstudio.com/t/fatal--error-C1001:-Internal-compiler-er/10906076
  )
endif()

if(ONNX_DISABLE_EXCEPTIONS)
  add_compile_definitions("ONNX_NO_EXCEPTIONS")
  # Disable C++ exceptions.
  if(MSVC)
    string(REGEX REPLACE "/EHsc" "/EHs-c-" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
    add_definitions(-D_HAS_EXCEPTIONS=0)
  else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-exceptions -fno-unwind-tables -fno-asynchronous-unwind-tables")
  endif()
endif()

# explicitly configure FindPython3.cmake to find python3 in virtual environment first
if(NOT DEFINED Python3_FIND_VIRTUALENV)
  set(Python3_FIND_VIRTUALENV FIRST)
endif()

if(NOT DEFINED Python3_FIND_STRATEGY)
  set(Python3_FIND_STRATEGY LOCATION)
endif()

if(CMAKE_CROSSCOMPILING)
  # When cross-compiling, the interpreter and the compiling/linking steps
  # must use a different package. See the discussion about this at
  # https://gitlab.kitware.com/cmake/cmake/-/issues/25145
  if(ONNX_BUILD_PYTHON)
    find_package(Python3 REQUIRED COMPONENTS Development.Module)
  endif()
  find_package(Python REQUIRED COMPONENTS Interpreter)
  set(ONNX_PYTHON_INTERPRETER Python::Interpreter)
else()
  if(ONNX_BUILD_PYTHON)
    set(python_dev_component Development.Module)
  endif()
  find_package(Python3 REQUIRED COMPONENTS Interpreter ${python_dev_component})
  set(ONNX_PYTHON_INTERPRETER Python3::Interpreter)
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "AIX")
  set(CMAKE_NO_SYSTEM_FROM_IMPORTED 1)
endif()

# Build the libraries with -fPIC including the protobuf lib.
if(NOT DEFINED CMAKE_POSITION_INDEPENDENT_CODE)
  set(CMAKE_POSITION_INDEPENDENT_CODE ON)
endif()

list(APPEND CMAKE_MODULE_PATH ${ONNX_ROOT}/cmake/external)
if(NOT ONNX_BUILD_CUSTOM_PROTOBUF)
  if((ONNX_USE_LITE_PROTO AND TARGET protobuf::libprotobuf-lite) OR ((NOT ONNX_USE_LITE_PROTO) AND TARGET protobuf::libprotobuf))
    # Sometimes we need to use protoc compiled for host architecture while linking
    # libprotobuf against target architecture. See https://github.com/caffe2/caffe
    # 2/blob/96f35ad75480b25c1a23d6e9e97bccae9f7a7f9c/cmake/ProtoBuf.cmake#L92-L99
    if(EXISTS "${ONNX_CUSTOM_PROTOC_EXECUTABLE}")
      message(STATUS "Using custom protoc executable")
      set(ONNX_PROTOC_EXECUTABLE ${ONNX_CUSTOM_PROTOC_EXECUTABLE})
    else()
      if(TARGET protobuf::protoc)
        set(ONNX_PROTOC_EXECUTABLE $<TARGET_FILE:protobuf::protoc>)
      endif()
    endif()
  else()
    # Customized version of find Protobuf. We need to avoid situations mentioned
    # in https://github.com/caffe2/caffe2/blob/b7d983f255ef5496474f1ea188edb5e0ac4
    # 42761/cmake/ProtoBuf.cmake#L82-L92 The following section is stolen from
    # cmake/ProtoBuf.cmake in Caffe2
    find_program(Protobuf_PROTOC_EXECUTABLE
                NAMES protoc
                DOC "The Google Protocol Buffers Compiler")

    # Only if protoc was found, seed the include directories and libraries. We
    # assume that protoc is installed at PREFIX/bin. We use get_filename_component
    # to resolve PREFIX.
    if(Protobuf_PROTOC_EXECUTABLE)
      set(ONNX_PROTOC_EXECUTABLE ${Protobuf_PROTOC_EXECUTABLE})
      get_filename_component(_PROTOBUF_INSTALL_PREFIX
                            ${Protobuf_PROTOC_EXECUTABLE} DIRECTORY)
      get_filename_component(_PROTOBUF_INSTALL_PREFIX
                            ${_PROTOBUF_INSTALL_PREFIX}/.. REALPATH)
      find_library(Protobuf_PROTOC_LIBRARY
                  NAMES protoc
                  PATHS ${_PROTOBUF_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}
                  NO_DEFAULT_PATH)
      if(ONNX_USE_LITE_PROTO)
        find_library(Protobuf_LITE_LIBRARY
          NAMES protobuf-lite
          PATHS ${_PROTOBUF_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}
          NO_DEFAULT_PATH)
      else()
        find_library(Protobuf_LIBRARY
          NAMES protobuf
          PATHS ${_PROTOBUF_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}
          NO_DEFAULT_PATH)
      endif(ONNX_USE_LITE_PROTO)
      find_path(Protobuf_INCLUDE_DIR google/protobuf/service.h
                PATHS ${_PROTOBUF_INSTALL_PREFIX}/include
                NO_DEFAULT_PATH)
      if(ONNX_USE_PROTOBUF_SHARED_LIBS)
        set(Protobuf_USE_STATIC_LIBS OFF)
      else()
        set(Protobuf_USE_STATIC_LIBS ON)
      endif()
      find_package(Protobuf)
      if(Protobuf_FOUND)
        set(PROTOBUF_DIR "${_PROTOBUF_INSTALL_PREFIX}")
        set(Build_Protobuf OFF)
        if("${Protobuf_VERSION}" VERSION_GREATER_EQUAL "4.22.0")
          # There are extra dependencies for protobuf.
          find_package(absl REQUIRED)
          find_package(utf8_range)
          message(STATUS "absl_VERSION: ${absl_VERSION}")
          set(protobuf_ABSL_USED_TARGETS
            absl::absl_check
            absl::absl_log
            absl::algorithm
            absl::base
            absl::bind_front
            absl::bits
            absl::btree
            absl::cleanup
            absl::cord
            absl::core_headers
            absl::debugging
            absl::die_if_null
            absl::dynamic_annotations
            absl::flags
            absl::flat_hash_map
            absl::flat_hash_set
            absl::function_ref
            absl::hash
            absl::layout
            absl::log_initialize
            absl::log_severity
            absl::memory
            absl::node_hash_map
            absl::node_hash_set
            absl::optional
            absl::span
            absl::status
            absl::statusor
            absl::strings
            absl::synchronization
            absl::time
            absl::type_traits
            absl::utility
            absl::variant
            utf8_range::utf8_range
            utf8_range::utf8_validity
          )
        endif()
      endif()
    endif()
  endif()
endif()
if(NOT ONNX_PROTOC_EXECUTABLE)
    set(Build_Protobuf ON)
    set(protobuf_MSVC_STATIC_RUNTIME ${ONNX_USE_MSVC_STATIC_RUNTIME})

    include(FetchContent)
    set(ABSL_PROPAGATE_CXX_STD 1)
    set(ONNX_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})
    set(ONNX_CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS})
    # Use this setting to build third-party libs.
    set(BUILD_SHARED_LIBS ${ONNX_USE_PROTOBUF_SHARED_LIBS})
    set(ProtobufURL https://github.com/protocolbuffers/protobuf/releases/download/v31.1/protobuf-31.1.tar.gz)
    set(ProtobufSHA1 da10aaa3bf779735a8a9acde1256a47ce5d148be)
    FetchContent_Declare(
      Protobuf
      URL ${ProtobufURL}
      URL_HASH SHA1=${ProtobufSHA1}
    )
    set(protobuf_BUILD_TESTS OFF CACHE BOOL "Build protobuf tests" FORCE)
    message(STATUS "Download and build Protobuf from ${ProtobufURL}")
    FetchContent_MakeAvailable(Protobuf)
    set(ONNX_PROTOC_EXECUTABLE $<TARGET_FILE:protobuf::protoc>)
    set(Protobuf_VERSION "6.31.1")
    # Change back the BUILD_SHARED_LIBS to control the onnx project.
    set(BUILD_SHARED_LIBS ${ONNX_BUILD_SHARED_LIBS})
    set(PROTOBUF_DIR "${protobuf_BINARY_DIR}")
    set(CMAKE_CXX_FLAGS ${ONNX_CMAKE_CXX_FLAGS})
endif()
message(STATUS "ONNX_PROTOC_EXECUTABLE: ${ONNX_PROTOC_EXECUTABLE}")

# function(RELATIVE_PROTOBUF_GENERATE_CPP SRCS HDRS ROOT_DIR) from https://githu
# b.com/tensorflow/tensorflow/blob/d2c3b873c6f8ff999a2e4ee707a84ff00d9c15a5/tens
# orflow/contrib/cmake/tf_core_framework.cmake to solve the problem that
# customized dir can't be specified when calling PROTOBUF_GENERATE_CPP.
function(RELATIVE_PROTOBUF_GENERATE_CPP SRCS)
  if(NOT ARGN)
    message(
      SEND_ERROR
        "Error: RELATIVE_PROTOBUF_GENERATE_CPP() called without any proto files"
      )
    return()
  endif()

  set(${SRCS})

  set(GEN_PROTO_PY "${ONNX_ROOT}/onnx/gen_proto.py")
  set(GENERATED_FILES)
  foreach(INFILE ${ARGN})
    set(ABS_FILE "${ONNX_ROOT}/${INFILE}")
    get_filename_component(FILE_DIR ${ABS_FILE} DIRECTORY)
    get_filename_component(FILE_WE ${INFILE} NAME_WE)
    # "onnx-data" check is because we do not want to create/compile an "onnx-data-ml.proto" file
    if(ONNX_ML AND NOT(FILE_WE STREQUAL "onnx-data"))
      if(ONNX_NAMESPACE STREQUAL "onnx")
        set(GENERATED_FILE_WE "${FILE_WE}-ml")

=== requirements.txt ===
numpy>=1.22
protobuf>=4.25.1
typing_extensions>=4.7.1
ml_dtypes>=0.5.0

=== docs/docsgen/Makefile ===
# Copyright (c) Sphinx Project
#
# SPDX-License-Identifier: BSD-2-Clause

# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line, and also
# from the environment for the first two.
SPHINXOPTS    ?=
SPHINXBUILD   ?= sphinx-build
SOURCEDIR     = source
BUILDDIR      = build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O) --keep-going

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O) --keep-going

=== docs/docsgen/source/requirements.txt ===
--- 
+++ 
@@ -4,7 +4,8 @@
 matplotlib
 myst-parser[linkify]
 onnx
-onnxruntime
+onnxruntime<1.20;python_version<"3.13"
+onnxruntime;python_version>="3.13"
 pillow
 pydot
 sphinx-copybutton

=== debian/changelog ===
onnx (1.19.1-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream version 1.19.1 (for PyTorch 2.9.x).
  * d/watch: switch to version 5.
  * d/patches: remove applied & expired patches.
  * d/control: bump std-ver to 4.7.2 (no changes required)
  * d/copyright: remove unused pattern.
  * d/lintian-overrides: remove unused rules.
  * d/py3dist-overrides: add python3-ml-dtypes.

 -- Shengqi Chen <harry@debian.org>  Thu, 23 Oct 2025 19:56:09 +0800

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: science
 Homepage: https://onnx.ai
 Priority: optional
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/deeplearning-team/onnx.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/onnx
 Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>

=== debian/watch ===
Version: 5
Template: GitHub
Owner: onnx
Project: onnx
RepackSuffix: +dfsg

## onnx 1.20.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,13 @@
 # Minimum CMake required
-cmake_minimum_required(VERSION 3.24)
+cmake_minimum_required(VERSION 3.26)
 # Project
 project(onnx LANGUAGES CXX)
 
 include(cmake/Utils.cmake)
 # Honor visibility properties for all target types.
 cmake_policy(SET CMP0063 NEW)
+# Modules FindPython3 and FindPython use LOCATION for lookup strategy.
+cmake_policy(SET CMP0094 NEW)
 
 # Set default build type
 get_property(isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
@@ -38,14 +40,7 @@
 endif()
 
 
-if(DEFINED BUILD_ONNX_PYTHON)
-  message(WARNING "'BUILD_ONNX_PYTHON' is deprecated. Please, use 'ONNX_BUILD_PYTHON' instead")
-  set(ONNX_BUILD_PYTHON_DEFAULT ${BUILD_ONNX_PYTHON})
-else()
-  set(ONNX_BUILD_PYTHON_DEFAULT OFF)
-endif()
-
-option(ONNX_BUILD_PYTHON "Build Python binaries" ${ONNX_BUILD_PYTHON_DEFAULT})
+option(ONNX_BUILD_PYTHON "Build Python binaries" OFF)
 option(ONNX_BUILD_CUSTOM_PROTOBUF "Build and use ONNX's own protobuf" OFF)
 option(ONNX_USE_PROTOBUF_SHARED_LIBS "Build ONNX using protobuf shared library." OFF)
 option(ONNX_GEN_PB_TYPE_STUBS "Generate protobuf python type stubs" ON)
@@ -134,13 +129,8 @@
   endif()
 endif()
 
-# explicitly configure FindPython3.cmake to find python3 in virtual environment first
-if(NOT DEFINED Python3_FIND_VIRTUALENV)
-  set(Python3_FIND_VIRTUALENV FIRST)
-endif()
-
-if(NOT DEFINED Python3_FIND_STRATEGY)
-  set(Python3_FIND_STRATEGY LOCATION)
+if(ONNX_BUILD_PYTHON)
+  set(python_dev_component Development.Module Development.SABIModule)
 endif()
 
 if(CMAKE_CROSSCOMPILING)
@@ -148,15 +138,15 @@
   # must use a different package. See the discussion about this at
   # https://gitlab.kitware.com/cmake/cmake/-/issues/25145
   if(ONNX_BUILD_PYTHON)
-    find_package(Python3 REQUIRED COMPONENTS Development.Module)
+    find_package(Python3 REQUIRED COMPONENTS ${python_dev_component})
   endif()
   find_package(Python REQUIRED COMPONENTS Interpreter)
   set(ONNX_PYTHON_INTERPRETER Python::Interpreter)
 else()
-  if(ONNX_BUILD_PYTHON)
-    set(python_dev_component Development.Module)
-  endif()
   find_package(Python3 REQUIRED COMPONENTS Interpreter ${python_dev_component})
+  # Find Python for nanobind
+  set(Python_EXECUTABLE ${Python3_EXECUTABLE})
+  find_package(Python REQUIRED COMPONENTS Interpreter ${python_dev_component})
   set(ONNX_PYTHON_INTERPRETER Python3::Interpreter)
 endif()
 
@@ -330,3 +320,10 @@
     if(ONNX_ML AND NOT(FILE_WE STREQUAL "onnx-data"))
       if(ONNX_NAMESPACE STREQUAL "onnx")
         set(GENERATED_FILE_WE "${FILE_WE}-ml")
+      else()
+        set(GENERATED_FILE_WE "${FILE_WE}_${ONNX_NAMESPACE}-ml")
+      endif()
+    else()
+      if(ONNX_NAMESPACE STREQUAL "onnx")
+        set(GENERATED_FILE_WE "${FILE_WE}")
+      else()

=== requirements.txt ===
numpy>=1.23.2
protobuf>=4.25.1
typing_extensions>=4.7.1
ml_dtypes>=0.5.0

=== onnx/test/cmake/CMakeLists.txt ===
# This minimal CMake file is used to test finding and linking ONNX from a main project
cmake_minimum_required(VERSION 3.26)
project(onnx_test LANGUAGES CXX)

find_package(ONNX REQUIRED CONFIG)

add_executable(main main.cc)
find_package(Protobuf REQUIRED CONFIG)
target_link_libraries(main ONNX::onnx protobuf::libprotobuf)

=== debian/changelog ===
onnx (1.20.0-1) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Shengqi Chen <harry@debian.org>  Mon, 12 Jan 2026 22:50:45 +0800

onnx (1.20.0-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream version 1.20.0.
  * d/patches: refresh existing patches.
  * d/control: bump std-ver to 4.7.3 (no changes), remove useless fields.
  * d/control: replace pybind11 with nanobind in B-D.
  * d/patches: do not hide symbols in onnx_object (required by onnxruntime).

 -- Shengqi Chen <harry@debian.org>  Fri, 09 Jan 2026 22:43:20 +0800

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: onnx
 Section: science
 Homepage: https://onnx.ai
-Priority: optional
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Git: https://salsa.debian.org/deeplearning-team/onnx.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/onnx
 Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
@@ -14,16 +13,15 @@
                cmake,
                libprotobuf-dev,
                protobuf-compiler,
-               pybind11-dev,
+               nanobind-dev,
                python3-all,
                python3-all-dev,
                python3-numpy <!nocheck>,
                python3-protobuf <!nocheck>,
-               python3-pybind11,
+               python3-nanobind,
                python3-pytest <!nocheck>,
                python3-pytest-runner,
                python3-tabulate <!nocheck>
-Rules-Requires-Root: no
 
 Package: python3-onnx
 Architecture: any
